subroutine revtime(ne, nr, mfp, t30,t50,t80, totalarea, arnum, surface, ellarea, absorber, ampmod,defin, alf, clarity,  ampcorr, definmax, ellfinal,elly,designrt,modclaritymin, ellfinalclarity)

! Establishing configurations with suitable RT's

implicit none


 
real, intent(in) :: ampmod(1000), mfp	,totalarea,	   ellarea(50),  designrt
real, intent(out) ::   alf(50), ampcorr(1000),definmax
 real, intent(inout) ::   defin, clarity ,modclaritymin	

real ::     reqabs,    TOTABS, totabs4

INTEGER(4), intent(in) :: ne, nr, T50, T80, arnum(1000),surface(1000,10), t30
INTEGER(4) :: NA, nu, guff, dig, dume ,  i,j,  k, m , in	, ku, grip ,ju 

 
type point
integer n1, n2
real xp, yp, zp
end type point

type element
integer ne1, ne2, nod1, nod2, nod3, nod4, abstype
end type element

type pointy
real :: x, y, z
end type pointy

type absorption
 real :: abs63, abs125, abs250, abs500, abs1000, abs2000, abs4000, abs8000
 end type absorption


 
type (absorption), dimension(10) :: absorber

type (element), intent(inout), dimension(50) :: elly
type (element),intent(out), dimension(50) ::  ellfinal ,ellfinalclarity



reqabs= (13.8*mfp)/(340*designrt) * totalarea

print*, "Required Absorption    ", reqabs


! Establish surfaces giving early reflections
do k=1, t30
do m= 1, arnum(k) 
if (surface(k,m)>4) then
    elly((surface(k,m)))%abstype = 1
	endif
end do
end do



!  OPTION - NUMBER OF ABSORBER TYPES   ********************************************************************************$$$$$$$
! ***************************************************************************************************************************

 ! na is number of absorber options

NA=2


 ! *******************************************************************************************
!Establish absorber kind per element - 

!Set absorption characteristics - elements 1 to 4 audience, floor to front of stage,  stage floor and stage front

! Note these are just guesses at the moment and only relate to one frequency (Assumed to be 500Hz)
  
 elly(1)%abstype=2
 elly(2)%abstype=3
 elly(3)%abstype=4
 elly(4)%abstype=4

 
! *****                                               OPTION - SELECTION OF ABSORBERS ***********************************
 ! ***********************************************************888********************************************************



! Absorbers 5 and 6 are selected treatments - one low frequency absorber and 1 high frequency absorber but still only one frequency
  !***************************************************************

! Absorber(1) is reflector
!************************
	  print*, "THIS FAR C"

! Absorption of fixed elements
ju=1
  totabs4  =0
      do in= 1,4
 	  totabs4 = totabs4 + ellarea(in)*absorber(elly(in)%abstype)%abs500 
	  alf(in) =	absorber(elly(in)%abstype)%abs500
  	  end do
  		  print*, "Absorption of fixed elements  ", totabs4

 !   k u will be used to store Indice of suitable configurations  **************************************
  ku= 0

nu = (na**(ne-4))-1

Do j= nu, 0, -1
	   
 
 guff= j
       
	 
! Note: Counting down to 5 as absorption for 4 elements has been fixed.	 
! As only 2 absorber choices are available the possiblities represent a binary word - each "bit" can be 1 or zero
! Set absorber accordingto bit value	 
	!	print*, " "
	!		print*, ne
	 
	 totabs = totabs4

	 do i= ne, 5, -1
	
	!	print*, guff
		grip= (na**(i-1-4))
	!	 print*, grip
	   dig = guff/grip
	!   print*, dig
	 ! 		  print*, "THIS FAR D"

	  ! DO I NEED THIS???
      dume=dig*	na**(i-1-4)
 	  guff = guff - dume
 	
	  if (elly(i)%abstype ==1) then
	  alf(i)= absorber(elly(i)%abstype)%abs500 
	  else	  
	  if (dig == 0) then 
     
 
	  elly(i)%abstype = 5
	  alf(i)= absorber(elly(i)%abstype)%abs500 
	  else 
	 if (dig == 1) then 
	   elly(i)%abstype = 6
	  alf(i)= absorber(elly(i)%abstype)%abs500 
	  end if
	  end if
	   	   	  
	  end if 
!	   	 print*, ellarea(i)
	  totabs = totabs + ellarea(i)*alf(i)
!	 ! 	print*, "this far F"
	  end do
	!print*, j, totabs
	 ! print*, totabs, totabs4


	! OPTION - CLOSENESS TO DESIGN RT  ******************************************************************************	  
	! ***************************************************************************************************************
	
  if (abs((reqabs -totabs)/reqabs)<0.1) then
		   !print*, 'Getting there', totabs, reqabs
		  
		 call criteria(nr,ampmod, t50, t80, alf, arnum, surface, defin, clarity,  ampcorr)

		   	 		   
		   if (defin>definmax) then
		  definmax = defin
		  ellfinal=elly
 			end if
		 
		 	  if (clarity<modclaritymin) then
		  modclaritymin = clarity
		  ellfinalclarity=elly
 			end if

		 end if
		  ! ***********************************
   end do
   print*,ju
  ! print*, alf
return
end