subroutine absorbo(absorber)
implicit none



type absorption
 real :: abs63, abs125, abs250, abs500, abs1000, abs2000, abs4000, abs8000
 end type absorption

type  (absorption), intent(out):: absorber(10)
 
  
		
		! Data for absorbers

! Reflector	 - RAYNOISE polished wood
absorber(1)%abs63=0.11
absorber(1)%abs125=0.10
absorber(1)%abs250=0.07
absorber(1)%abs500=0.05
absorber(1)%abs1000=0.05
absorber(1)%abs2000=0.04
absorber(1)%abs4000=0.04
absorber(1)%abs8000=0.03



!  Audience Absorption - RAYNOISE 1 person per sq metre
absorber(2)%abs63=0.16
absorber(2)%abs125=0.17
absorber(2)%abs250=0.24
absorber(2)%abs500=0.56
absorber(2)%abs1000=0.69
absorber(2)%abs2000=0.81
absorber(2)%abs4000=0.78
absorber(2)%abs8000=0.75


! Floor	 - RAYNOISE carpet
absorber(3)%abs63=0.02
absorber(3)%abs125=0.02
absorber(3)%abs250=0.06
absorber(3)%abs500=0.13
absorber(3)%abs1000=0.46
absorber(3)%abs2000=044
absorber(3)%abs4000=0.56
absorber(3)%abs8000=0.66

!Stage Construction - RAYNOISE wooden platform
absorber(4)%abs63=0.41
absorber(4)%abs125=0.4
absorber(4)%abs250=0.3
absorber(4)%abs500=0.2
absorber(4)%abs1000=0.17
absorber(4)%abs2000=0.15
absorber(4)%abs4000=0.1
absorber(4)%abs8000=0.12

! High Frequency Sound Absorber	 - RAYNOISE rock wool
absorber(5)%abs63=0.12
absorber(5)%abs125=0.14
absorber(5)%abs250=0.6
absorber(5)%abs500=0.7
absorber(5)%abs1000=073
absorber(5)%abs2000=0.75
absorber(5)%abs4000=0.85
absorber(5)%abs8000=0.83

! Low Frequency Sound Absorber - RAYNOISE wooden platform
absorber(6)%abs63=0.41
absorber(6)%abs125=0.4
absorber(6)%abs250=0.3
absorber(6)%abs500=0.2
absorber(6)%abs1000=0.17
absorber(6)%abs2000=0.15
absorber(6)%abs4000=0.1
absorber(6)%abs8000=0.12

absorber(7)%abs63=0
absorber(7)%abs125=0
absorber(7)%abs250=0
absorber(7)%abs500=0.1
absorber(7)%abs1000=0
absorber(7)%abs2000=0
absorber(7)%abs4000=0
absorber(7)%abs8000=0

absorber(8)%abs63=0
absorber(8)%abs125=0
absorber(8)%abs250=0
absorber(8)%abs500=0.1
absorber(8)%abs1000=0
absorber(8)%abs2000=0
absorber(8)%abs4000=0
absorber(8)%abs8000=0

absorber(9)%abs63=0
absorber(9)%abs125=0
absorber(9)%abs250=0
absorber(9)%abs500=0.1
absorber(9)%abs1000=0
absorber(9)%abs2000=0
absorber(9)%abs4000=0
absorber(9)%abs8000=0

absorber(10)%abs63=0
absorber(10)%abs125=0
absorber(10)%abs250=0
absorber(10)%abs500=0.1
absorber(10)%abs1000=0
absorber(10)%abs2000=0
absorber(10)%abs4000=0
absorber(10)%abs8000=0

return
end
