subroutine reflect(nr, time, amp, arnum, surface, ampmod, t30, t50, t80, ne, intelm, extelm)


implicit none
real, intent(out) ::   time(1000), amp(1000),   ampmod(1000) 
 real :: ah, av,arh,arv	, td, phase	, x1, y1, z1
integer(4), intent(out) :: nr, arnum(1000),surface(1000,10), t50, t80, t30
integer(4), intent(in) :: ne, intelm(50), extelm(50) 
 
 integer(4) :: 	 ns, inttime(1000) , k, m , kiss




 ! INPUT DATA FROM RAYNOISE FILE   ************************************************************************************
   ! Reflectogram Data


do k=1, nr
read(9,*) ns, time(k),amp(k), phase, arnum(k)
read(9,*) ah, av,arh,arv
!print*, ns, time(k),amp(k), phase, arnum(k)

  do m= 1, arnum(k)
  read(9,*) surface(k,m), x1, y1, z1
   print*, surface(k,m)
    
	
	! Re-numbering elements to match internal numbering system   *************************************************
			! m????????????????
  
         do kiss = 1, ne
       if (surface(k,m)==extelm(kiss)) then
        surface(k,m) = intelm(kiss)
     !print*, surface(k,m)
     end if
         end do
 
   ! ***********************************************************************************************************
    
! Changing node numbers which define elements into internal numbering system ******************************************************
  	! nn ????????????????

	
	
	end do

 end do
 

	   ! Direct Sound **************************************************************************************************

td = time(1)
 t30 =0
 T50=0
 T80 = 0
! print*, amp

do k=1,nr
! Zeroing time **************************
! Setting arrival time relative to arrival of direct sound***********
time(k)=time(k)-td
! *******************************************

!  Linearising amplitude ***********************
 ampmod(k) = 10.0**(amp(k)/10.0)
  !print*, amp(k) , ampmod(k)


!*****************************************
       

  !Expressing time delay as integer  (0.1 msec)     **********
   
  inttime(k) = time(k) +0.5
   
! Establishing break point - early/late sound
   
   	  if(inttime(k)<20) then
   t30 = k
	end if


   
   
   if(inttime(k)<50) then
   t50 = k
	end if

   if(inttime(k)<80) then
   t80 = k
   end if
   
   
   end do


            

return
end